package net.pricefx.common.apibuilder.chart;

import java.math.BigDecimal;
import java.util.Date;

import net.pricefx.common.apibuilder.BacklinkBuilder;
import net.pricefx.common.apibuilder.ObjectIdentity;

public class Formula<S extends ObjectIdentity> extends BacklinkBuilder<S> {

	public Formula(final S backLink, final String instanceId, final String classId) {
		super(instanceId, classId, backLink);
	}

	public Formula<S> setFormulaName(final String formulaName) {
		addInvocation("setFormulaName",formulaName);
		return this;
	}

	public Formula<S> setTargetDate(final Date date) {
		addInvocation("setTargetDate",date);
		return this;
	}

	public Formula<S> addInputParameter(final String inputParamName, final BigDecimal value) {
		addInvocation("addInputParameter",inputParamName, value);
		return this;
	}
	
	public Formula<S> addInputParameter(final String inputParamName, final String value) {
		addInvocation("addInputParameter",inputParamName, value);
		return this;
	}
}