package net.pricefx.domain;

import com.googlecode.genericdao.search.Filter;
import net.pricefx.formulaengine.ResultOverride;
import net.pricefx.server.dto.calculation.ContextParameter;
import net.pricefx.workflowengine.Workflow;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

public interface CompensationAgreementRecord {

    Long getId();

    String getName();

    String getUniqueName();

    boolean isManual();

    String getTypedId();

    Map<String, CalculationResult> getCalculationResultsAsMap();

    String getSourceId();

    String getRecordSetLabel();

//    String getUniqueNamePrefix(final PersistedObjectService objService);

//    SellerReference getSeller();

    Map<String, ContextParameter> getInputsMap();

    String getLineId();

    Class getAgreementClass();

//    DMDataSlice getCalculationBase();

    void setRank(Integer rank);

    void setLabel(String label);

    void setStartDate(LocalDateTime startDate);

    void setEndDate(LocalDateTime endDate);

    void setPayoutDate(LocalDateTime payoutDate);

    void setCustomerGroup(CustomerGroup customerGroup);

    void setProductGroup(ProductGroup productGroup);

//    void setCalculationBase(DMDataSlice calculationBase);

    void setManualOverrides(Map<String, ResultOverride> manualOverrides);

//    void setSeller(SellerReference seller);

    void setLastUpdateDate(LocalDateTime lastUpdateDate);

    void setCompleteCalculationResultsFromList(List<CalculationResult> calcDTOs);

    void setUserGroupEdit(String userGroup);

    void setUserGroupViewDetails(String userGroup);

    void setPartition(Partition p);

    void setSourceId(String sourceId);

    void setLineId(String lineId);

    void setName(String name);

    void setCreateDate(LocalDateTime createDate);

    void setUniqueName(String uniqueName);

//    void setConditionType(AbstractConditionType conditionType);

    void setAgreementTerms(Map<String, Object> agreementTerms);

    void setInputs(List<ContextParameter> inputs);

//    void setHeaderType(HeaderType headerType);

    void clearMessages();

    LocalDateTime getTargetDate();

    void addMessage(String message);

    void setCalculationStatus(int summaryStatus);

    List<String> getMessages();

    void setFormulaName(final String formulaName);

    String getConditionTypeUniqueName();

    CustomerGroup getCustomerGroup();

    ProductGroup getProductGroup();

    LocalDateTime getStartDate();

    LocalDateTime getEndDate();

    List<ContextParameter> getInputs();

    String getManualOverrides();

    Map<String, ResultOverride> getManualOverridesAsMap();

    List<CalculationResult> getCompleteCalculationResultsAsList();

    boolean hasCompleteResultsAvailable();

    Map<String, Object> getAgreementTerms();

    void setCalculationDate(LocalDateTime calculationDate);

    int getFieldLength();

    void setAllowedOverrides(String allowedOverrides);

    void setSuffixes(Map<String, String> suffixes);

    void setCellStyles(Map<String, String> cellStyles);

    void setOverrideValueOptions(Map<String, List<Object>> options);

    void setWarnings(Map<String, List<String>> warnings);

    void setAlerts(Map<String, String> alerts);

    Class getConditionTypeClass();

    int getCalculationStatus();

    Map<String, ContextParameter> getAgreementInputsAsMap();

    void setManualOverrides(String manualOverrides);

    void setTargetDate(LocalDateTime targetDate);

    LocalDateTime getCalculationDate();

//    void setApprovalState(ApprovalState approvalState);

    String getLabel();

    Workflow.WorkflowStatus getWorkflowStatus();

    Map<String, Object> getAllAttributesMap(boolean useLabels, boolean useElementNames);

    void setIsManual(Boolean isManual);

    void setDescription(String description);

    String getDescription();

    LocalDateTime getPayoutDate();

    String jsonSerialize() throws RuntimeException;

    Long getVersion();

    Partition getPartition();

//    ApprovalState getApprovalState();

    void setComments(String comment);

//    boolean canEdit(User user, ValidationVisitor validationVisitor, PersistedObjectService objService);

    String typeName();

//    Msg getCalculatedMsg();
//
//    Msg getCalculatedWithErrorsMsg();
//
    String getFormulaElementGroup();

//    Search buildCompAgreementPayoutRecordSearch(Filter... filters);

}
