package net.pricefx.server.util.metamodel;

import java.util.ArrayList;
import java.util.List;

import org.apache.metamodel.schema.AbstractTable;
import org.apache.metamodel.schema.Relationship;
import org.apache.metamodel.schema.TableType;

import com.fasterxml.jackson.annotation.JsonIgnore;


public class Table extends AbstractTable {

	private static final long serialVersionUID = 1L;
	
	protected final List<org.apache.metamodel.schema.Column> columns = new ArrayList<>();
	protected final Schema schema;
	protected final TableType type;
	protected final String remarks;
	protected final String name;

	
	protected Table(final String name, final TableType type, final Schema schema, final String remarks) {
		this.name = name;
		this.type = type;
		this.schema = schema;
		this.remarks = remarks;
	}

	public Column getColumn(final String columnName) {
		return (Column) super.getColumnByName(columnName);
	}
	  
	@Override
	public List<org.apache.metamodel.schema.Column> getColumns() {
		return columns;
	}

	@JsonIgnore
	@Override
	public Schema getSchema() {
		return schema;
	}

	@Override
	public TableType getType() {
		return type;
	}

	@Override
	public List<Relationship> getRelationships() {
		return null;
	}

	@Override
	public String getRemarks() {
		return remarks;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public String getQuote() {
		return null;
	}

}