package net.pricefx.service;

import net.pricefx.domain.RebateRecordSet;

public class RebateRecordSummaryQuery extends ItemSummaryQuery<RebateRecordSet>{

	public RebateRecordSummaryQuery() {
		super("rebateRecordSetId");
	}

	protected String resolveFieldName(Object calcObjItem, String fieldNameOrLabel, String alias, Object objService){
		if (fieldNameOrLabel != null)		
			switch(fieldNameOrLabel){
				case "label":
				case "sourceId":
				case "lineId":
				case "startDate":
				case "endDate":
				case "rebateTypeUN":
				case "status":
				case "customerGroup.customerFieldName":
				case "customerGroup.customerFieldLabel":
				case "customerGroup.customerFieldValue":
				case "productGroup.productFieldName":
				case "productGroup.productFieldLabel":
				case "productGroup.productFieldValue":
					return fieldNameOrLabel;
				case "rebateType":
					return "rebateTypeUN";
				case "customerFieldName":
					return "customerGroup.customerFieldName";
				case "customerFieldLabel":
					return "customerGroup.customerFieldLabel";
				case "customerFieldValue":
					return "customerGroup.customerFieldValue";
				case "productFieldName":
					return "productGroup.productFieldName";
				case "productFieldLabel":
					return "productGroup.productFieldLabel";
				case "productFieldValue":
					return "productGroup.productFieldValue";
				default:
					break;
			}
		return null;

	}

}
